<br/>
<center>
<p align="center">
  <a href="https://github.com/Moonlight-Panel/Moonlight">
    <img src="https://my.endelon-hosting.de/api/moonlight/resources/images/logo.svg" alt="Logo" width="80" height="80">
  </a>

  <h3 align="center">Moonlight Panel</h3>

  <p align="center">
    The next generation hosting panel
  </p>
</p>

![Contributors](https://img.shields.io/github/contributors/Moonlight-Panel/Moonlight?color=dark-green) ![Stargazers](https://img.shields.io/github/stars/Moonlight-Panel/Moonlight?style=social) ![Issues](https://img.shields.io/github/issues/Moonlight-Panel/Moonlight) 

## About The Project
</center>

Moonlight is a new free and open-source alternative to Pterodactyl,
allowing users to create their own hosting platform and host all sorts of game servers in Docker containers.
The moonlight panel was originaly developed for Endelon Hosting and has been split into a independent project.
The goal of moonlight is to provide an all in one solution for hosting businesses and communities for selling, hosting and
using varios services like webspaces, subdomains and docker based servers

If you have any questions or want to chat with us, feel free to join our discord
[https://discord.gg/TJaspT7A8p](https://discord.gg/TJaspT7A8p)

Moonlight's core features are

* Hosting game servers using Wings and Docker
* Creating and managing webspaces using the CloudPanel based web hosting solution
* Adding your domains as shared domains and providing subdomains for users with them
* Live ticket system
* Subscription system
* Statistics
* and many more

This project is currently in beta

## Built With



* [Bootstrap 5](https://getbootstrap.com/)
* [Blazor Server Side](https://learn.microsoft.com/de-de/aspnet/core/blazor/hosting-models?view=aspnetcore-7.0)
* [.NET 6](https://dotnet.microsoft.com/en-us/download/dotnet/6.0)

## Getting Started


### Prerequisites

* Linux based operating system
* Docker
* MySQL/MariaDB Database
* A domain (optional)

### Installation

A full guide on how to install moonlight can be found here:
[https://docs.moonlightpanel.xyz/installing-moonlight](https://docs.moonlightpanel.xyz/installing-moonlight)

Quick installer/updater:
`curl https://install.moonlightpanel.xyz/installer > install.sh; bash install.sh`
You'd need to select what to install: The Panel, Wings or the daemon

Having any issues?
We are happy to help on our Discord server:
[https://discord.gg/TJaspT7A8p](https://discord.gg/TJaspT7A8p)

## Roadmap

The roadmap can be found here:
[https://github.com/orgs/Moonlight-Panel/projects/1](https://github.com/orgs/Moonlight-Panel/projects/1)

## Contributing

* If you have suggestions for adding or removing projects, feel free to open an issue to discuss them.
* Please make sure you check your spelling and grammar.
* Create individual PR for each suggestion.

### Creating A Pull Request

1. Fork the Project
2. Create your Feature Branch (`git checkout -b feature/AmazingFeature`)
3. Commit your Changes (`git commit -m 'Add some AmazingFeature'`)
4. Push to the Branch (`git push origin feature/AmazingFeature`)
5. Open a Pull Request

## License

Distributed under the Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International Public License. See [LICENSE](https://github.com/Moonlight-Panel/Moonlight/blob/main/LICENSE.md) for more information.

## Authors

* **Marcel Baumgartner** - *Endelon Hosting* - [Marcel Baumgartner](https://github.com/Marcel-Baumgartner) - *Moonlights core system & frontend*
* **Daniel Balk** - *Endelon Hosting* - [Daniel Balk](https://github.com/Daniel-Balk) - *Notification system & frontend*
* **Spielepapagei** - *Endelon Hosting* - [Spielepapagei](https://github.com/Spielepapagei) - *Discord Bot & support tickets*
* **Dannyx** - *None* - [Dannyx](https://github.com/Dannyx1604) - *Grammer check and translations*

## Some screenshots
Only user area (outdated)
![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121635286443634768/dashboard.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121635662475571261/serverlist_.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121635784685002762/console_.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121635898933657741/filemanager_.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121636024162992128/filemanager_move_.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121636204358672494/filemanager_editor.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121636339285237820/backups.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121636510182150215/addons.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121636623784890519/settings.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121636741170855967/webspace_overview.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121636848670875668/webspace_files.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121636950953177138/webspace_databases.png)

![Screen Shot](https://cdn.discordapp.com/attachments/1059911407170228234/1121637134797918259/domains_.png)
